**Script Language for Tasmota**  

As an alternative to rules. (about 11.3k flash size, variable ram size)  

In submenu Configuration =\> edit script  
1535 bytes max script size (uses rules buffer)

Up to 45 variables (40 numeric and 5 strings, maybe changed by #define)  
Freely definable variable names  
Nested if,then,else up to a level of 8  
Math operators  **+,-,\*,/,%,&,|,^**  
all operators may be used in the op= form e.g. **+=**  
Left right evaluation with optional brackets  
all numbers are float  
e.g. temp=hum\*(100/37.5)+temp-(timer\*hum%10)  
Comparison operators **==,!=,\>,\>=,<,<=**  
**and** , **or** support  

strings support **+** and **+=** operators  
string comparison **==,!=**  
max string size = 19 chars (default,can be increased or decreased by optional >DEF parameter)  

**Comments** start with **;**  

**Sections** defined:  

>**\>D ssize**  
ssize = optional max stringsize (default=19)  
define and init variables here, must be the first section, no other code allowed  
**p:**vname specifies permanent vars  
**t:**vname specifies countdown timers, if >0 they are decremented in seconds  until zero is reached. see example below  
**i:**vname specifies auto increment counters if >=0 (in seconds)  

>all variable names length taken together may not exceed 256 characters, so keep variable names as short as possible.  
memory is dynamically allocated as a result of the DEF section.  
copying a string to a number or reverse is supported   

>**\>B**  
executed on BOOT time  

>**\>T**  
executed on teleperiod time (**SENSOR** and **STATE**), get tele vars only in this section  

>**\>S**  
executed every second  

>**\>E**  
executed e.g. on power change  

special variables:  

>**upsecs** = seconds since start  
**uptime** = minutes since start  
**time** = minutes since midnight  
**sunrise** = sunrise minutes since midnight  
**sunset** = sunset minutes since midnight  
**tstamp** = timestamp (local date and time)  
**topic** = mqtt topic  
**gtopic** = mqtt group topic  
**prefixn** = prefix n = 1-3    
**power[x]** = tasmota power state  (x = 1-N)  
**sw[x]** = tasmota switch state  (x = 1-N)  
>**pin[x]** = gpio pin level (x = 0-16)  
**pn[x]** = pin number for sensor code x, 99 if none  
**pd[x]** = defined sensor for gpio pin nr x none=999  
**gtmp** = global temperature  
**ghum** = global humidity  
**gprs** = global pressure

these variables auto clr after reading  
>**chg[var]** = true if a variable has changed  
**boot** = true on BOOT  
**tinit** = true on time init  
**tset** = true on time set  
**mqttc** = true on mqtt connect  
**mqttd** = true on mqtt disconnect  
**wific** = true on wifi connect  
**wifid** = true on wifi disconnect  
**stack** = stack size  
**heap** = heap size  
**ram** = used ram size  
**slen** = script lenght  

remarks:
if you define a variable with the same name as a special
variable that special variable is discarded  


**Tasmota** cmds start with **=\>**  
within cmds you can replace text with variables with **%varname%**  
a single percent sign must be given as **%%**  

**special** cmds:

>**=\> print** prints to web console  

to save code space nearly no error messages are provided. However it is taken care of that at least it should not crash on syntax errors.  
if a variable does not exist a **???** is given on commands  
if a **SENSOR** or **STATUS** message or a var does not exist the destination variable is NOT updated.  

2 possibilities for conditionals:  
>**if** a==b  
**and** x==y  
**or** k==i  
**then** => do this  
**else** => do that  
**endif**  

OR  

>**if** a==b  
**and** x==y  
**or** k==i **{**  
  => do this  
**} else {**  
  => do that  
**}**  

also possible e.g.  

>if var1-var2==var3*var4  
then  

remarks:  
the last closing bracket must be on a single line  
the condition may not be enclosed in brackets  

>**break** exits a section or terminates a for next loop  
**dprecx** sets decimal precision to x (0-9)  
**delay(x)** pauses x milliseconds (should be as short as possible)  
**=spin(x m)** set gpio pin x (0-16) to value m (0,1) only the last bit is used, so even values set the pin to zero and uneven values set the pin to 1  
**=spinm(x m)** set pin mode gpio pin x (0-16) to mode m (input=0,output=1)  

>**#name** names a subroutine, subroutines are called with **=#name**  
**#name(param)** names a subroutines with a parameter is called with **=#name(param)**  
subroutines end with the next '#' or '>' line or break, may be nested  
params can be numbers or strings and on mismatch are converted  

**for var from to inc**  
**next**  
specifies a for next loop

***example script***  
meant to show some of the possibilities  

**\>D**  

p:mintmp=10  (p:means permanent)  
p:maxtmp=30  
t:timer1=30  (t:means countdown timer)  
hello=&quot;hello world&quot;  
string=&quot;xxx&quot;  
url=&quot;[192.168.178.86]&quot;  
hum=0  
temp=0  
timer=0  
dimmer=0  
sw=0  
oldsw=0  
rssi=0  
param=0  
t:mt=0  
i:count=0  
param=0

**\>B**  

string=hello+"how are you?"  
=\>print BOOT executed  
=\>print %hello%  
=\>mp3track 1  

; list gpio pin definitions
for cnt 0 16 1  
tmp=pd[cnt]  
=>print %cnt% = %tmp%  
next  

; get gpio pin for relais 1
tmp=pn[21]
=>print relais 1 is on pin %tmp%

; pulse relais over raw gpio  
spin(tmp 1)  
delay(100)  
spin(tmp 0)  

; raw pin level  
=>print level of gpio1 %pin[1]%  

; pulse over tasmota cmd
=>power 1  
delay(100)  
=>power 0  

**\>T**  

hum=BME280#Humidity  
temp=BME280#Temperature  
rssi=Wifi#RSSI  
string=SleepMode  

sw=Switch1  
if sw!=oldsw  
then oldsw=sw  
=\>power1 %sw%  
endif  

if temp\>30  
and hum\>70  
then =\>print damn hot!  
endif  

**\>S**  

; every second but not completely reliable time here  
; use upsecs and uptime or t: for reliable timers  

; call subrountines with parameters   
=#sub1("hallo")  
=#sub2(999)  

if timer1==0  
then timer1=-1  
=>print timer1 expired  
endif  

if count>=10  
then =>print 10 seconds over  
count=0  
endif  

if upsecs%5==0  
then =\>print %upsecs%  (every 5 seconds)  
endif  

timer+=1  
if timer\>=5  
then =\>print timer=%timer%  
timer=0  
endif  

dimmer+=1  
if dimmer\>100  
then dimmer=0  
endif  

=\>dimmer %dimmer%  
=\>WebSend %url% dimmer %dimmer%  

dprec0  
=\>displaytext [c1l1f1s2p20] dimmer=%dimmer%  

=\>print %upsecs% %uptime% %time% %sunrise% %sunset% %tstamp%  

if time\>sunset  
and time\<sunrise  
then  
 ; night time  
 if power1==0  
 then  
  =\>power1 1  
 endif  
else  
 ; day time  
 if power1\>0  
 then  
  =\>power1 0  
 endif  
endif  

if mqqtc\>0  
then =\>print mqqt connected  
endif  

if boot\>0  
then =\>displaytext [z]  
endif  

; frost warning  
if temp<0  
and mt<=0  
then =#sendmail("frost alert")  
; alarm only every 5 minutes  
mt=300  
=>mp3track 2  
endif  

; var has changed
if chg[hello]>0  
then =>print %hello%  
endif  

; subroutines  
#sub1(string)  
=>print sub1: %string%  
#sub2(param)  
=>print sub2: %param%  

#sendmail(string)  
=>sendmail [smtp.gmail.com:465:user:passwd:<sender@gmail.de>:<rec@gmail.de>:test] %string%  

**\>E**  

hello=&quot;event occured&quot;  

=\>print event executed!  
